$(function(){

	izbranaBarva = $("#barva").val();
			
	var tmpTime = [];		
	function barvaj(celica, cls) {

		if (celica.length==0) return;
		if (celica.attr("class")!=cls) return;
		
		// dodamo class
		celica.addClass(izbranaBarva);
		
		var hTime = setTimeout(function() {		
			barvaj(celica.next(), cls);
			barvaj(celica.prev(), cls);
			barvaj(celica.parent().next().children().eq(celica.index()), cls);
			barvaj(celica.parent().prev().children().eq(celica.index()), cls);
			
			barvaj(celica.parent().next().children().eq(celica.index()).next(), cls);
			barvaj(celica.parent().next().children().eq(celica.index()).prev(), cls);
			
			barvaj(celica.parent().prev().children().eq(celica.index()).next(), cls);
			barvaj(celica.parent().prev().children().eq(celica.index()).prev(), cls);
			
		}, 20);
		tmpTime.push(hTime);
	}

	function pocistiBarve() {
		// prekinemo barvanje
		while (i = tmpTime.pop()) clearTimeout(i);
		
		// odstranimo class
		$(tabela).find("."+izbranaBarva).removeClass(izbranaBarva);
	}

	$("#barva").change(function(){
		pocistiBarve();
		izbranaBarva = $(this).val();		
	});
	
	var tabela = $("<table>");
	
	function nalozi(value) {
		tabela.empty();
		var slika = eval(value);
		
		var sirina = slika[0];
		var visina = (slika.length-1)/slika[0];
		
		$("#dimenzija").text("š: "+sirina+" px, v: "+visina+" px");
		
		// ustvarimo tabelo
		for (var i = 0; i < visina; i++) {
			var vrstica = $("<tr>");
			for (var j = 0; j < sirina; j++) {
				var celica = $("<td>");
				celica.addClass("siva"+slika[i*sirina+j+1]);
				vrstica.append(celica);
			}
			tabela.append(vrstica);
		}
		
		$(tabela).find("td").mouseover(function(){
			pocistiBarve();
							 
			// pobarvamo
			barvaj($(this), $(this).attr("class"));
		});
	}
				
		
	$("body").append(tabela);
	
	$("#slika").change(function(){
		nalozi($(this).val());		
	});
	
});
